<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<title>Perl6 Community Development Server</title>

<link rel="stylesheet" type="text/css" href="http://search.cpan.org/s/style.css"
    title="Perl-flavoured style" media="screen" />
</head>

<body>

<h1>Perl6 Community Development Server</h1>

<p>
This server, known as "feather", is dedicated to the development
of Perl6. It provides free resources to Perl6 contributors, including:
</p>

<ul>
<li> A shell account </li>
<li> A recent version of pugs to work with </li>
<li> <a href="svk.html">svk</a> for source control. (Like svn, but faster) </li>
<li> Web space (<a href="~">listing</a>) </li>
<li> <a href="https://feather.perl6.nl/irc/">IRC chat</a> (Freenode #perl6) </li>
<li> <a href="https://feather.perl6.nl/mail/">Mail</a> </li>
</ul>

<p>
See <a
href="http://www.mail-archive.com/perl6-language@perl.org/msg20060.html">the
original announcement</a> for details.
</p>

<h2>Getting Started with Perl6</h2>

<p>
We maintain our own Perl6 documentation index here. It's cross-referenced
with the test suite to make it super useful. 
</p>

<ul>
<li><a href="http://feather.perl6.nl/syn/">Perl6 Documentation</a></li>
</ul>

<p>
Further useful information can be found through our sister sites;
</p>

<ul>
    <li> <a href="http://perl6.org/">Perl 6</a> </li>
    <li> <a href="http://rakudo.org/">Rakudo</a> </li>
    <li> <a href="http://modules.perl6.org/">Perl 6 Modules</a> </li>
    <li> Pugs 
        <ul>
            <li> <a href="http://pugs.blogs.com/">The Pugs' Blog</a></li>
            <li> <a href="http://www.pugscode.org/">pugscode.org</a></li>
            <li> <a href="http://perlcabal.org/svn/pugs/">Pugs SVN Browser</a></li>
            <li> <a href="http://irc.pugscode.org/">IRC Logs</a></li>
            <li> <a href="http://invite.pugscode.org/">Commitbit</a>, interface to invite others to code Pugs.</li>
        </ul>
    </li>
    <li> <a href="http://perlfoundation.org/perl6/index.cgi">Perl 6 Wiki</a>, focused on Perl 6 users. </li>
    <li> Perl 6 blog aggregator available at <a href="http://planetsix.perlfoundation.org/">PlanetSix</a></li>
</ul>


<hr />

<h2>Getting started on Feather</h2>

<p>
Once you have an account, you can publish files in <a href="~/">~/public_html</a> and they
will be accessible at <a href="~/">http://feather.perl6.nl/~foo/</a>.
</p>

<p>
To find out what users are doing here and what they have to say, <a
href="/cgi-bin/finger.pl">finger</a> them. They can hide their ~/.plan from the
outside world by creating a ~/.nofinger file.
</p>

<hr />

<h2>FAQ: Can I use CGI/mod_perl on feather?</h2>

<p>
Yes, but not via the default Apache. Every form of web development requires
specific settings, and that makes maintenance hard. It is, however, very easy
to run your own Apache. Here's how:
</p>

<blockquote>
<pre>
cp -rp ~juerd/apache ~
perl -i -pe's/juerd/$ENV{USER}/g' ~/apache/httpd.conf
perl -i -pe's/Listen 8000/"Listen " . (7000 + $&lt;)/e' ~/apache/httpd.conf
</pre>
</blockquote>

<p>
To start your web server, run <tt>/usr/sbin/apache -f ~/apache/httpd.conf</tt>.
To stop it, run <tt>killall apache</tt> (ignore that it couldn't kill the
system wide apaches).
</p>

<h2>FAQ: How do I redirect my feather email to my other mail address?</h2>

<p>
Use qmail's .qmail system. See <tt>man dot-qmail</tt> for details.
</p>
<blockquote>
<pre>
echo '&amp;other-address@example.org' &gt; ~/.qmail
</pre>
</blockquote>

<h2>FAQ: How can I upload files to feather?</h2>

<p>
Via SFTP or SCP, that both work over SSH. Consult the manpages for detailed
instructions. The simplest invocations are:
</p>

<blockquote>
<pre>
scp some.file username@feather.perl6.nl:      # puts it in your homedir
scp some.file username@feather.perl6.nl:path  # uploads to path

sftp username@feather.perl6.nl                # provides an FTP-like CLI
</pre>
</blockquote>

<p>
Windows users can use the <tt>pscp</tt> and <tt>psftp</tt> instead. These
utilities can be found on the <a
href="http://www.chiark.greenend.org.uk/~sgtatham/putty/download.html">PuTTY
Download Page</a>.
</p>

<p>
Alternatively, for Windows there's also a nice graphical utility called <a
href="http://winscp.net/">WinSCP</a>, and for Unixlike systems there are
several integrated solutions, like the "<a
href="sftp://feather.perl6.nl/">sftp://</a>" protocol in Konqueror and
Nautilus. 
</p>

<h2>FAQ: Can I keep a script running on feather?</h2>

<p>
Sure you can, as long as you use the "sleep" command or something like that.
</p>

<p>
If you're trying to instruct feather to do certain things periodically, please consider
using the <i>cron</i> program. There's a <a
href="http://www.unixgeeks.org/security/newbie/unix/cron-1.html">cron
tutorial</a>.
</p>

<p>
Use of the "crontab -e" command on feather is strongly recommended.
</p>

<p>
If you are looking for automatic refreshing of the pugs source tree, you can
always read ~audreyt/pugs/, which is constantly being updated from svn via evalbot
according to Audrey.
</p>

<h2>FAQ: How can I override the default charset of feather's Apache?</h2>

<p>
Simply create a .htaccess file under your ~/public_html/ with the following line in it:
</p>

<blockquote>
<pre>
AddCharset UTF-8 .html
</pre>
</blockquote>

<p>
This example specifies UTF-8, but you should have it match your document. After
that, Apache will use the encoding you've specified in .htaccess for all the
.html files in the current directory <i>and</i> all its subdirectories.
</p>

<p>
Apache loads .htaccess on every request, so there should be no delay once
you have set this.
</p>

<hr />

<p>
This web site is in Pugs' repository, in docs/feather. If you have the time and
skills to improve it, please do not hesitate. The site is synced every 15
minutes.  
</p>

<form method="get" action="http://www.google.com/search" style="position: absolute; top: 5px; right: 5px; text-align: right; ">
<p>
<input type="hidden" name="ie" value="UTF-8" />
<input type="hidden" name="oe" value="UTF-8" />
<input type="hidden" name="domains" value="feather.perl6.nl" />
<input type="hidden" name="sitesearch" value="feather.perl6.nl" />
<input type="text" name="q" size="31" maxlength="255" value="" /> 
<input type="submit" name="btnG" value="Google Search on feather.perl6.nl" />
</p>
</form>

</body>
</html>
